/*
 *
 * ATM Switch Control Library - swctl
 * 	by miwa@mt.cs.keio.ac.jp, 1997
 * $Id: swctlsw.c,v 1.1.4.1 1998/09/02 04:02:30 onoe Exp $
 *
 */

#include <sys/types.h>
#include <sys/time.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <ctype.h>
#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "swctl.h"

swctl_switch_attr_t *
switch_attr_search(swctl_switch_attr_t *sw_attr_list, switch_id_t sw)
{
    swctl_switch_attr_t *sw_attr;

    for(sw_attr = sw_attr_list; sw_attr; sw_attr = sw_attr->next)
      if(sw_attr->id == sw)
	return(sw_attr);

    return((swctl_switch_attr_t *)NULL);
}

swctl_switch_attr_t *
switch_attr_delete(swctl_switch_attr_t *sw_attr_list, switch_id_t sw)
{
    swctl_switch_attr_t	*current;
    swctl_switch_attr_t	*previous;
    swctl_switch_attr_t	*return_list;

    return_list = sw_attr_list;

    for(current = sw_attr_list,
	previous = (swctl_switch_attr_t *)NULL;
	current;
	previous = current, current = current->next) {
	
	if( current->id == sw ) {

	    if( !previous ) {
		/* delete switch_attr_list head entry */
		return_list = current->next;
	    }
	    else {
		/* delete switch_attr_list mid or tail entry */
		previous->next = current->next;
	    }
	    if(current->upc_table_list)
	      free_upc_table_list(current->upc_table_list);
	    free(current);
	    break;
	}
    }

    return(return_list);
}
